#!/usr/bin/env perl
# $Id: cew.cgi,v 1.1.1.1 2004/11/03 09:40:29 yto Exp $
use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use POSIX qw(strftime);

my $q = new CGI;

my $now = time;
my $datafile = "data.html";
my $tpl = << "TPL"
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=EUC-JP">
<title>ContentEditableWiki</title>
</head>
<body>%%%CONT%%%
<hr>
Powered by <a href="http://nais.to/~yto/tools/contenteditablewiki/">ContentEditableWiki</a>
</body>
</html>
TPL
    ;

print "Content-type: text/html; charset=EUC-JP\n\n";

my $lastupdate = (stat $datafile)[9];

if ($q->param('mode') eq 'save') {
    my $lastaccess = $q->param('time');
    my $text = $q->param('text');
    if ($lastaccess < $lastupdate) { # conflict
	my $con = << "CONF"
ʤ񤭹¾οͤ񤭹ǤṹޤǤ
<a href="@{[$q->url()]}" target="_blank"></a>٤ꤤޤ
<hr>ʤ񤭹⤦Ȥ: 
<div style="background-color: #e0e0e0; padding:20pt">$text</div>
CONF
;
	$tpl =~ s!%%%CONT%%%!$con!e;
	print $tpl;
    } else {
	$text =~ s!<iframe!</iframe.*>!gsmi;
	$text =~ s!<script!</script.*>!gsmi;
	save_file($datafile, $text);
	print qq(<html><head><META HTTP-EQUIV="Refresh" 
		 CONTENT="1;URL=@{[$q->url()]}"></head></html>);
    }
} else {
    my $all = read_file($datafile);
    my $lustr = strftime "%Y-%m-%dT%H:%M:%S", localtime($lastupdate);
    my $con = << "CONT"
<script language="JavaScript">
<!--
    function save() {
	if(navigator.appName.indexOf("Microsoft") >= 0){
	    document.all.text.innerText = document.all.area.innerHTML;
	    document.all.form.submit();
	} else {
	    alert("Sorry. IE Only");
	}
    }
    function markup(tag) {
	t = document.selection.createRange();
	tt = t.text;
	t.pasteHTML("<"+tag+">"+tt+"</"+tag+">");
    }
    function link() {
	t = document.selection.createRange();
	tt = t.text;
	u = prompt("URL","http://");
	t.pasteHTML('<a href="'+u+'">'+tt+"</a>");
    }
    function image() {
	t = document.selection.createRange();
	tt = t.text;
	u = prompt("URL","http://");
	t.pasteHTML('<img src="'+u+'" alt="'+tt+'">');
    }
    function color(c) {
	t = document.selection.createRange();
	tt = t.text;
	t.pasteHTML("<font color="+c+">"+tt+"</font>");
    }
    function deleteTags() {
	t = document.selection.createRange();
	tt = t.text;
	t.pasteHTML(tt.replace("<[^>]+>"," "));
    }
    function listn(tag) {
	t = document.selection.createRange();
	tt = t.text.replace(/\\n/g,"\\n<li>");
	t.pasteHTML("<"+tag+"><li>"+tt+"</"+tag+">");
    }
    function toggle() {
	if (document.all.area.contentEditable == "true") {
	    document.all.area.contentEditable = "false";
	    document.all.area.style.height = "";
	    document.all.area.style.overflow = "";
	    document.all.toggle.innerText = "Խ";
	    document.all.menu.style.display = "none";
	} else {
	    document.all.area.contentEditable = "true";
	    document.all.area.style.height = "400pt";
	    document.all.area.style.overflow = "scroll";
	    document.all.toggle.innerText = "";
	    document.all.menu.style.display = "";
	}
    }
//-->
</script>
<a id="toggle" href='javascript:toggle()'>Խ</a>
<span id="menu" style="display: none">
| <a href="javascript:markup('b')"><b>B</b></a>
| <a href="javascript:markup('i')"><i>I</i></a>
| <a href="javascript:markup('u')"><u>U</u></a>
| <a href="javascript:markup('s')"><s>S</s></a>
| <a href="javascript:markup('tt')"><tt>TT</tt></a>
| <a href="javascript:markup('big')"><big>BIG</bog></a>
| <a href="javascript:markup('small')"><small>SMALL</small></a>
| <a href="javascript:listn('ul')">UL</a>
| <a href="javascript:listn('ol')">OL</a>
| <a href="javascript:markup('h1')">H1</a>
| <a href="javascript:markup('h2')">H2</a>
| <a href="javascript:markup('h3')">H3</a>
| <a href="javascript:color('red')"></a>
| <a href="javascript:color('blue')"></a>
| <a href="javascript:color('green')"></a>
| <a href="javascript:link()">URL</a>
| <a href="javascript:image()"></a>
| <a href="javascript:deleteTags()"></a>
| <a href="javascript:save()">¸</a>
</span>
<span style="display: none">
<form action="cew.cgi" method="post" name="form">
<input type="submit"><input type="hidden" name="mode" value="save">
<input type="hidden" name="time" value="$now">
<textarea name="text" rows=0 cols=0></textarea></form></span>
<br/>last update $lustr
<hr>
<div style="border: solid 1px gray; padding:20pt"
id="area" contenteditable="false">$all</div>
CONT
    ;
    $tpl =~ s!%%%CONT%%%!$con!e;
    print $tpl;
}

sub read_file {
    my ($fn) = @_;
    return "file open error or login incorrect!" if (not open(F, $fn));
    my $c = join('', (<F>));
    close F;
    return $c;
}

sub save_file {
    my ($fn, $str) = @_;
    if (open(F, "> $fn")) {
	binmode(F);
	flock(F, 2);
	$str =~ s/\r//g;
	print F $str;
	close F;
	chmod 0666, $fn;
    }
}
